#include "Vram.h"
#include "Chars.h"

extern void _deb();
extern byte[] MonoPattern, ColorPattern;

void InitVram()
{
    InitVdc();
    InitColors();
    InitMonoChar(Char_Ascii, MonoPattern, 64, 7);
    InitMonoChar(Char_Logo, MonoPattern + Char_Logo * CharHeight, 16, 14);
    InitColorChar(Char_Floor, ColorPattern, Char_End - Char_Floor);
}


word PrintC(word vram, byte c)
{
    return Put(vram, c - ' ');
}


void Put2C(byte x, byte y, byte c)
{
    word vram;
    vram = VramAddress(x, y);
    repeat (2) {
        repeat (2) {
            vram = Put(vram, c);
            ++c;
        }
        vram += VramRowSize - VramStep * 2;
    }
}


void Erase2(byte x, byte y)
{
    word vram;
    vram = VramAddress(x, y);
    repeat (2) {
        repeat (2) {
            vram = Put(vram, Char_Space);
        }
        vram += VramRowSize - VramStep * 2;
    }
}
